package com.gxwebsoft.shop.controller;

import com.gxwebsoft.common.core.web.BaseController;
import com.gxwebsoft.common.system.entity.User;
import com.gxwebsoft.shop.service.ShopMerchantCountService;
import com.gxwebsoft.shop.entity.ShopMerchantCount;
import com.gxwebsoft.shop.param.ShopMerchantCountParam;
import com.gxwebsoft.common.core.web.ApiResult;
import com.gxwebsoft.common.core.web.PageResult;
import com.gxwebsoft.common.core.web.PageParam;
import com.gxwebsoft.common.core.web.BatchParam;
import com.gxwebsoft.common.core.annotation.OperationLog;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.List;

/**
 * 门店销售统计表控制器
 *
 * @author 科技小王子
 * @since 2024-09-10 21:05:07
 */
@Api(tags = "门店销售统计表管理")
@RestController
@RequestMapping("/api/shop/shop-merchant-count")
public class ShopMerchantCountController extends BaseController {
    @Resource
    private ShopMerchantCountService shopMerchantCountService;

    @ApiOperation("分页查询门店销售统计表")
    @GetMapping("/page")
    public ApiResult<PageResult<ShopMerchantCount>> page(ShopMerchantCountParam param) {
        // 使用关联查询
        return success(shopMerchantCountService.pageRel(param));
    }

    @ApiOperation("查询全部门店销售统计表")
    @GetMapping()
    public ApiResult<List<ShopMerchantCount>> list(ShopMerchantCountParam param) {
        PageParam<ShopMerchantCount, ShopMerchantCountParam> page = new PageParam<>(param);
        page.setDefaultOrder("create_time desc");
        return success(shopMerchantCountService.list(page.getOrderWrapper()));
        // 使用关联查询
        //return success(shopMerchantCountService.listRel(param));
    }

    @PreAuthorize("hasAuthority('shop:shopMerchantCount:list')")
    @OperationLog
    @ApiOperation("根据id查询门店销售统计表")
    @GetMapping("/{id}")
    public ApiResult<ShopMerchantCount> get(@PathVariable("id") Integer id) {
        return success(shopMerchantCountService.getById(id));
        // 使用关联查询
        //return success(shopMerchantCountService.getByIdRel(id));
    }

    @ApiOperation("添加门店销售统计表")
    @PostMapping()
    public ApiResult<?> save(@RequestBody ShopMerchantCount shopMerchantCount) {
        if (shopMerchantCountService.save(shopMerchantCount)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @ApiOperation("修改门店销售统计表")
    @PutMapping()
    public ApiResult<?> update(@RequestBody ShopMerchantCount shopMerchantCount) {
        if (shopMerchantCountService.updateById(shopMerchantCount)) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @ApiOperation("删除门店销售统计表")
    @DeleteMapping("/{id}")
    public ApiResult<?> remove(@PathVariable("id") Integer id) {
        if (shopMerchantCountService.removeById(id)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

    @ApiOperation("批量添加门店销售统计表")
    @PostMapping("/batch")
    public ApiResult<?> saveBatch(@RequestBody List<ShopMerchantCount> list) {
        if (shopMerchantCountService.saveBatch(list)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @ApiOperation("批量修改门店销售统计表")
    @PutMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody BatchParam<ShopMerchantCount> batchParam) {
        if (batchParam.update(shopMerchantCountService, "id")) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @ApiOperation("批量删除门店销售统计表")
    @DeleteMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody List<Integer> ids) {
        if (shopMerchantCountService.removeByIds(ids)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

}
